#property copyright "bc"
#property link  ""
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Green
#property indicator_color4 Magenta//? i not intend to show signal line of idt, will this occupy limited 8 buffer space or indicator lines?
#property indicator_color5 Aqua//?i not intend to show signal line of idt,will this occupy limited 8 buffer space or indicator lines?
#property indicator_color6 Lime//?i not intend to show signal line of idt, will this occupy limited 8 buffer space or indicator lines?



#property indicator_level1 0
#property indicator_level2 100
#property indicator_level3 -100

extern int MA_Period = 5;
extern int MA_Method = MODE_LWMA;
extern int CCI_Period = 14;
extern int applied_price = 0; 


extern string TimeFrame     = "Current time frame";
//extern int TimeFrame=0;

extern string Exsymbola="AUDUSD";

int      timeFrame;
bool     calculateValue;
bool     returnBars;
string   indicatorFileName;






double CCI_idx1[], CCI_idx2[], CCI_idx3[],CCI_idt1[],CCI_idt2[],CCI_idt3[];
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
  {
    
 
//---- indicators
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,CCI_idx1);
 
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,CCI_idx2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,CCI_idx3);
  SetIndexStyle(3,DRAW_LINE);//i not intend to show signal line of idt,  will this occupy limited 8 buffer space or indicator lines?
   SetIndexBuffer(3,CCI_idt1);
   SetIndexStyle(4,DRAW_LINE);//i not intend to show signal line of idt,  will this occupy limited 8 buffer space or indicator lines?
   SetIndexBuffer(4,CCI_idt2);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,CCI_idt3);//i not intend to show signal line of idt,  will this occupy limited 8 buffer space or indicator lines?
  
  
  
  
  
  indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+" smoothed CCI");
  
  
  
    
   
//----
   return(0);
  }
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
  {
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
       if (returnBars) { CCI_idx1[0] = limit+1; return(0); }
         if (!calculateValue)
      
         
         
         

for(i=limit;i>=0;i--) 
   
   {CCI_idt2[i] =getCCI2(i);//use this code part to substitue (A) below
   
   }  
   



   for(i=limit;i>=0;i--) CCI_idt1[i] = iCCI(NULL,TimeFrame,CCI_Period,applied_price,i);
   for(i=limit;i>=0;i--) CCI_idx1[i] = iMAOnArray(CCI_idt1,0,MA_Period,0,MA_Method,i); 
   
   //(A) for(i=limit;i>=0;i--) CCI_idt2[i] = ((iCCI("EURUSD",TimeFrame,CCI_Period,applied_price,i)+iCCI("EURAUD",TimeFrame,CCI_Period,applied_price,i)+iCCI("EURJPY",TimeFrame,CCI_Period,applied_price,i))/3);
   for(i=limit;i>=0;i--) CCI_idx2[i] = iMAOnArray(CCI_idt2,0,MA_Period,0,MA_Method,i); 
   
    for(i=limit;i>=0;i--) CCI_idt3[i] = iCCI(Exsymbola,TimeFrame,CCI_Period,applied_price,i);
   for(i=limit;i>=0;i--) CCI_idx3[i] = iMAOnArray(CCI_idt3,0,MA_Period,0,MA_Method,i); 
   
   
 
     
   
   return(0);
}


 double getCCI2(int pos)  //use this code part to substitue (A) above
   
   {double CCI2;
   double r1,r2,r3;
   r1=iCCI("EURUSD",TimeFrame,CCI_Period,applied_price,pos);
   r2=iCCI("EURAUD",TimeFrame,CCI_Period,applied_price,pos);
    r3=iCCI("EURJPY",TimeFrame,CCI_Period,applied_price,pos);
    
    CCI2=(r1+r2+r3)/3;
    
    return (CCI2);
    
    }
  
  
  
  
  

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("M" + DoubleToStr(timeFrame,0));
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}